#!/usr/bin/env python
import sys
import math
import re
import hmm.tr_obj as tr_obj
import hmm.HMM_IO as HMM_IO
import hmm.algo_HMM as algo_HMM
from  pkg_resources  import  resource_filename

def filterSS(ss):
    ''' '''
    pat=re.compile('H+')
    TH=7
    groupSS=pat.search(ss)
    while groupSS:
         b,e=groupSS.span()
         lseg = e-b
         if lseg < TH:
           ss=ss[:b]+'C'*lseg+ss[e:]
         groupSS=pat.search(ss,e)
    return ss


def predmod(seq):
    modpath=resource_filename(__name__,  'mod')
    hmm=HMM_IO.load_cPickle(modpath+'/modc7cPickle.mod')
    (bestpath,bestVal)=algo_HMM.maxAcc_decoder(hmm,seq)
    ss=''.join(filterSS( ''.join(bestpath) ))
    (m,bestpath,lp)=algo_HMM.sum_aposteriori(hmm,seq,Scale='yes',label_list=hmm.label_list)
    score=0.0
    num=0
    plen=len(seq)
    cclab=hmm.label_list.index('H')
    for i in range(plen):
        if (bestpath[i] == 'H') : # coiled coils
            score+=m[i][cclab]
    s=score/plen-1
    prob=math.exp(-8.0*s*s)
    return ss,prob


outstr= '''
This software is under this license:

===========================================================

    Copyright (C) 2007 Piero Fariselli

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    PHMM lib Copyright (C) 2007  Piero Fariselli
    contacts: Piero Fariselli
              e-mail: piero@biocomp.unibo.it, piero.fariselli@unibo.it
              Dept. of Biology
              University of Bologna
              via Irnerio 42
              40126 Bologna
              Italy
    This program comes with ABSOLUTELY NO WARRANTY; for details type psCoils.py.
    This is free software, and you are welcome to redistribute it
    under the condition of preserving this text
===========================================================

In order to be used just

type

$ pred.py file.in

where file.in must contains the protein sequence in the form
of protein profile. Each line is one sequence position
and the order of the profile is:
# the order of the 20 symbol is : V L I M F W Y G A P S T C H R K Q E N D


The output consits of two lines:
the first line assign probability to contain a coiled-coil segment. 
The second line assign a putative prediction in which the symbol 'H'
represent possible coiled-coil positions.
However, the probability must be also taken into account.

Please for any use of this software cite the paper: 
Bartoli L, Fariselli P, Krogh A, Casadio R (2009) 
-CCHMM_PROF: a HMM-based coiled-coil predictor with evolutionary information- Bioinformatics 25:2757-2763 (2009) 

'''



